/*;  khrbktree.h {\documentstyle{jsrc2latex}\font\tenrm=cmtt10} */

/*;  $$Revision: 1.2 $$ {\rhead{\sl khrbktree.h\quad\thepage}} */
/*;  $$Date: 1997/09/14 09:55:42 $$  */
/*;  $$Source: /home/shiiba/KhC++LibDevelop/trees/khrbktree.h,v $$  */

// @(#) index Ĥ tree

/*

ΥإåեǤϡĤΥ饹졢μΤΥ
ɤͿƤޤ

Ƥ륯饹ϼ̤Ǥ

KhKeyedData<KeyType,DataType>

KhKeyTree<KeyType,DataType>
KhKeyTreeIterator<KeyType,DataType>

KhRbKeyTree<KeyType,DataType>
KhRbKeyTreeIterator<KeyType,DataType>

ϡtrbktree.cc 

------------------------------------------------------------------
* 饹 KhKeyedData<KeyType,DataType>

KeyType μֹ DataType ΥǡȤȤߤ碌ǡ


Υǡ羮طϡKeyType Υǡ mKey Ф
Ƥ羮طޤmKey ƱΥǡ
Ȥߤʤޤ (operator == Τ褦Ƥޤ)

Υǡϡ饹 KhKeyTree<KeyType,DataType> ʤɤǻȤ
ޤuser ľܼ갷ɬפϡ̤Ϥޤ

------------------------------------------------------------------
* 饹 KhKeyTree<KeyType,DataType>

KhKeyedData<KeyType,DataType> ǤȤƼǼ2ʬڤΥ


饹 KhKeyTree<KeyType,DataType> ޤ
дؿ

  KhKeyedData<KeyType, DataType>* GetPtrToData(KeyType i);

ɲƤޤ

㤨Сint ΥǡǼ̤ǡ¤ͤȤޤ
 int Ȥơ¼Υǡ Man Ȥȡ

  KhKeyTree<int,Man> tree;

Ƥ

------------------------------------------------------------------
* 饹 KhKeyTreeIterator<KeyType,DataType>

饹 KhKeyTree<KeyType,DataType> 2ʬڤФ iterator
Υ饹

㤨С

  KhKeyTreeIterator<int,Man> itr(tree);

Ȥޤ

------------------------------------------------------------------
* 饹 KhRbKeyTree<KeyType,DataType>

KhKeyedData<KeyType,DataType> ǤȤƼǼRed Black2ʬ
ڤΥ饹

饹 KhRedBlackTree<KhKeyedData<KeyType,DataType> > 
ޤ

дؿ

  KhKeyedData<KeyType, DataType>* GetPtrToData(KeyType i);

ɲƤޤ

------------------------------------------------------------------
* 饹 KhRbKeyTreeIterator<KeyType,DataType>

饹 KhRbKeyTree<KeyType,DataType> 2ʬڤФiteratorΥ
饹

*/

#ifndef khbirtree_h
#define khbirtree_h

#include "khstr.h"
#include "khbintree.h"
#include "khbintree.cc"

#include "khrbtree.h"
#include "khrbtree.cc"

#include <iostream.h>

template <class KeyType, class DataType>
class KhKeyedData {
  /*
    KeyType Υǡ DataType ΥǡȤȤߤ碌ǡ
    

    Υǡ羮طϡKeyType Υǡ mKey 
    ФƤ羮طޤmKey Ʊ
    ǡȤߤʤޤ (operator == )

    KeyType ΥǡФΥե󥹤֤ؿ Key(),
    DataType ΥǡФΥե󥹤֤ؿ Data() 
    Ƥޤ

  */

 protected:
  KeyType mKey;		// key
  DataType mData;	// data

 public:

  KhKeyedData()
  {
    //
  }

  KeyType&		// key ǡФؤλ
  Key()			// key ǡФؤλȤ֤
  {
    return mKey;
  }

  DataType&		// data ǡФؤλ
  Data()		// data ǡФؤλȤ֤
  {
    return mData;
  }

  KhKeyedData<KeyType,DataType>&
                        // keyĤǡؤλ
  operator[](		// keyꤹ
    KeyType aId		// ꤹ key
    )
  {
    mKey = aId;
    return *this;
  }

  KhKeyedData(		// 󥹥ȥ饯
    const KeyType& aId,	// key
    const DataType& aData) // data
  {
    mKey = aId;
    mData = aData;
  }

  KhKeyedData<KeyType,DataType>&
                        // դkeyĤǡؤλȡ
  operator = (		// 黻
    const KhKeyedData<KeyType,DataType>& aIdData)
                        // դkeyĤǡ
  {
    if (this != &aIdData) {
      mKey = aIdData.mKey;
      mData = aIdData.mData;
    }
    return *this;
  }

  int			// Ƚ
  operator < (		// ӱ黻 <
    const KhKeyedData<KeyType,DataType>& aIdData) // 
       const
  {
    return (mKey < aIdData.mKey);
  }

  int			// Ƚ
  operator == (		// Ƚ黻
    const KhKeyedData<KeyType,DataType>& aIdData) const	// 
  {
    // mKey ȽǤơƱ mKey ĥǡ
    // Ͽʤ
    return (mKey == aIdData.mKey);
  }

};

template <class KeyType, class DataType>
class KhKeyTree
: public KhBinaryTree<KhKeyedData<KeyType,DataType> >
{
  /*
    KhKeyedData<KeyType,DataType> ǤȤƼǼ2ʬڤ
    饹

    饹 KhBinaryTree<KhKeyedData<KeyType,DataType> > 
    ޤ

    дؿ

    KhKeyedData<KeyType, DataType>* GetPtrToData(KeyType i);

    ɲƤޤ

  */
 public:
  KhKeyedData<KeyType, DataType>*
                 // keyĤǡؤΥݥ
  GetPtrToData(	 // ꤷkeykeyĤǡؤΥݥ󥿤
		 // 
    KeyType aKey // keyλ
    )
  {
    KhKeyedData<KeyType, DataType> data;
    return KhBinaryTree<KhKeyedData<KeyType, DataType>
           >::GetPtrToData(data[aKey]);
  }

  void
  Insert(		   // keyĤǡ
    const KeyType& aKey,   // key λ
    const DataType& aData) // data λ
  {
    KhBinaryTree<KhKeyedData<KeyType,DataType>
    >::Insert(KhKeyedData<KeyType,DataType>(aKey, aData));
  }

  KhBoolean		  // NO: ꤷǡ̵
  Delete(		  // ꤷkeykeyĤǡõ
    const KeyType& aKey)  // keyλ
  {
    KhKeyedData<KeyType, DataType> data;
    KhBinaryTree<KhKeyedData<KeyType,DataType>
    >::Delete(data[aKey]);
  }
};

template <class KeyType, class DataType>
class KhKeyTreeIterator
: public KhBinaryTreeIterator<KhKeyedData<KeyType,DataType> >
{
  /*
    饹 KhKeyTree<KeyType,DataType> 2ʬڤФ
    iterator Υ饹
  */
 public:
  KhKeyTreeIterator(	// 󥹥ȥ饯
    KhBinaryTree<KhKeyedData<KeyType,DataType> >& tree
			// оݤȤ2ʬ
    )
    : KhBinaryTreeIterator<KhKeyedData<KeyType, DataType> >(tree)
  {
  //
  }
};

template <class KeyType, class DataType>
class KhRbKeyTree
: public KhRedBlackTree<KhKeyedData<KeyType,DataType> >
{
  /*
    KhKeyedData<KeyType,DataType> ǤȤƼǼRed
    Black2ʬڤΥ饹

    饹 KhRedBlackTree<KhKeyedData<KeyType,DataType> > 
    ޤ

    дؿ

    KhKeyedData<KeyType, DataType>* GetPtrToData(KeyType i);

    ɲƤޤ
  */
 public:
  KhKeyedData<KeyType, DataType>*
  GetPtrToData(		// ꤷkeykeyĤǡؤΥݥ
			// 󥿤֤
    KeyType aKey)	// key λ
  {
    //
    KhKeyedData<KeyType, DataType> data;
    return KhRedBlackTree<KhKeyedData<KeyType, DataType>
    >::GetPtrToData(data[aKey]);
  }

  void
  Insert(		// keyĤǡ
    const KeyType& aKey, // key λ
    const DataType& aData) // data λ
  {
    KhRedBlackTree<KhKeyedData<KeyType,DataType>
    >::Insert(KhKeyedData<KeyType,DataType>(aKey, aData));
  }

  KhBoolean		// NO/ꤷǡƤʤ
  Delete(		// keyĤǡκ
    const KeyType& aKey) // key λ
  {
    KhKeyedData<KeyType, DataType> data;
    return KhRedBlackTree<KhKeyedData<KeyType,DataType>
    >::Delete(data[aKey]);
  }

};

template <class KeyType, class DataType>
class KhRbKeyTreeIterator
: public KhRBTreeIterator<KhKeyedData<KeyType, DataType> >
{
  /*
    饹 KhRbKeyTree<KeyType,DataType> 2ʬڤФ
    iteratorΥ饹
  */
 public:
  KhRbKeyTreeIterator(	// 󥹥ȥ饯
    KhRedBlackTree<KhKeyedData<KeyType,DataType> >& tree)
                        // оݤȤ2ʬ
    : KhRBTreeIterator<KhKeyedData<KeyType, DataType> >(tree)
  {
  //
  }
};

#endif

/*; end of file */
